--
-- XML2DDL body by D.A.T.A. 
--	last modified on 13th May 2003
--

-- package body
Create or replace package body DATA_XML2DDL
AS

	DTD_URL	VARCHAR2(1024) Default 'http://medusa.inf.elte.hu/oradoc9/dbdtd.txt';
	
	-- location of DTD:
	-- returns location:
	Function GETDTDLocation RETURN VARCHAR2
	IS
	Begin
		Return DTD_URL;
	End;
	
	-- sets location:
	Procedure SETDTDLocation (newloc VARCHAR2)
	IS
	Begin
		DTD_URL := newloc;
	End;

	-- reverts to default location:
	Procedure DEFAULTDTDLocation
	IS
	Begin
		DTD_URL := 'http://medusa.inf.elte.hu/oradoc9/dbdtd.txt';
	End;


	-- Transforms the ref value from Table.Column format
	-- to Table(Column) format.
	Function getTransformedColRef(NLtablelist xmldom.DOMNodeList, Nrefnode xmldom.DOMAttr) Return Varchar2
	IS
	tableelem xmldom.DOMElement;
	collist xmldom.DOMNodeList;
	refstr varchar2(2000);
	tablenamenode xmldom.DOMAttr;
	idx number;
	f boolean;
	ff boolean;
	i number;
	j number;
	Begin
		f:=False;
		for i IN 0..xmldom.getLength(NLtablelist)-1
		Loop
			--TBLA
			tableelem := xmldom.makeelement(xmldom.item(NLtablelist, i));
			--TBLANV
			tablenamenode:=xmldom.getAttributeNode(tableelem, 'name'); 
			refstr :=xmldom.getvalue(Nrefnode);			
			idx :=instr(refstr, '.');
			if idx=0 then 
				raise INVALID_TABLEREF;
			end if;
			if xmldom.getvalue(tablenamenode)=substr(refstr,1,idx-1) then
				-- found the specified tablename
				F:=True;
				-- OSZLOP
				collist := xmldom.getElementsByTagName(tableelem, 'coloumn');		
				-- searching for the column name
				ff:=False;
				for j IN 0..xmldom.getLength(collist)-1
				Loop
					if substr(refstr,idx+1)=xmldom.getvalue(xmldom.getAttributeNode(xmldom.makeelement(xmldom.item(collist, j)),'name')) then
						ff:=True;
					end if;		
				End Loop;
				if not ff then 	
					-- col name not found
					raise INVALID_COLUMNREF;
				end if;
			end if;
		End Loop;
		if not f then 	
			-- tab name not found
			raise INVALID_TABLEREF;
		end if;
	
		Return REPLACE(xmldom.getvalue(NRefnode),'.','(') || ')';
	End;

	-- Transforms the value from 'col1 col2 ...' format 
	-- to 'col1,col2,...' format
	Function getTransformedColRef2(NLcollist xmldom.DOMNodeList, valuenode xmldom.DOMAttr) Return Varchar2
	IS 
	i Number;
	tmp varchar2(2000);
	idx Number;
	colnamenode xmldom.DOMAttr;
	f Boolean;
	result varchar2(2000);
	Begin
		tmp :=trim(xmldom.getvalue(valuenode));
		result :='';
		While (Length(tmp)>0)
		Loop
			idx :=instr(tmp,' ');
			if idx=0 then
				idx :=length(tmp)+1;
			end if;
			f:=False;
			for i IN 0..xmldom.getLength(NLcollist)-1
			Loop
				if substr(tmp,1,idx-1)=xmldom.getvalue(xmldom.getAttributenode(xmldom.makeelement(xmldom.item(NLcollist,i)),'name')) then
					f:=True;
				End if;
					
			End Loop;	
			if length(result)>0 then	
				result :=result || ',';
			end if;

			result :=result || substr(tmp,1,idx-1);

			if not f then
				raise INVALID_COLUMNREF;
			end if;
			tmp :=trim(substr(tmp,idx));
		End Loop;		

		Return result;
			--REPLACE(xmldom.getvalue(valuenode),' ',',');
	End;

	-- Creates the primary key part of the SQL
	-- Beginning with a SPACE character
	Function getPrimaryKeyDescr(NLcollist xmldom.DOMNodeList, NLkeylist xmldom.DOMNodeList, IsConstr Boolean) Return Varchar2
	IS 
	S Varchar(2000);
	j Number;
	keyelem xmldom.DOMElement;
	keynamenode xmldom.DOMAttr;
	valuenode xmldom.DOMAttr;
	Begin
		if not IsConstr then
			Return '';	
		else
			S:='';
			for j IN 0..xmldom.getLength(NLkeylist)-1
			Loop
				keyelem :=xmldom.makeelement(xmldom.item(NLkeylist,j));
				keynamenode :=xmldom.getAttributeNode(keyelem, 'name'); 
				valuenode :=xmldom.getAttributeNode(keyelem, 'pk'); 
				S:=S || ', Constraint ' || 
					xmldom.getvalue(keynamenode) || 
					' Primary Key(' || getTransformedColRef2(NLcollist,valuenode) || ')';
			End Loop;
			Return S;
		End if;
	End;

	-- Creates the foreign key part of the SQL
	-- Beginning with a SPACE character
	Function getForeignKeyDescr(NLcollist xmldom.DOMNodeList, NLtablelist xmldom.DOMNodeList, NLkeylist xmldom.DOMNodeList, IsConstr Boolean) Return Varchar2
	IS 
	S Varchar(2000);
	i Number;
	j Number;
	found Boolean;
	keyelem xmldom.DOMElement;
	keynamenode xmldom.DOMAttr;
	compositenode xmldom.DOMAttr;
	parentnode xmldom.DOMAttr;
	valuenode xmldom.DOMAttr;

        tableelem xmlDOM.DOMElement;
	Begin
		if not IsConstr then
			Return '';	
		else
			S:='';
			for j IN 0..xmldom.getLength(NLkeylist)-1
			Loop
				keyelem :=xmldom.makeelement(xmldom.item(NLkeylist,j));
				keynamenode :=xmldom.getAttributeNode(keyelem, 'name'); 
				compositenode :=xmldom.getAttributeNode(keyelem, 'composite'); 
				parentnode :=xmldom.getAttributeNode(keyelem, 'parent'); 

				-- check the tablenames for existence
				found :=False;
				for i IN 0..xmldom.getLength(NLtablelist)-1
				Loop
					tableelem := xmldom.makeelement(xmldom.item(NLtablelist,i));
					if xmldom.getvalue(parentnode) = xmldom.getvalue(xmldom.getAttributeNode(tableelem, 'name')) then
						found :=True;
					end if;
				End loop;
				if not found then
					raise INVALID_TABLEREF;
				End if;

				S:=S || ', Constraint ' || 
					xmldom.getvalue(keynamenode) || 
					' Foreign Key(' || getTransformedColRef2(NLcollist, compositenode) || 
					') References ' || xmldom.getvalue(parentnode);
			End Loop;
			Return S;
		End if;
	End;

	-- Creates the column part of the 'create table' sql
	Function getColumnDescr(NLtablelist xmldom.DOMNodeList, NLcollist xmldom.DOMNodeList) Return Varchar2
	IS 
	j number(4);
	S Varchar2(2000);
	colelem xmlDOM.DOMElement;
	colnamenode xmldom.DOMAttr;
	coltypenode xmldom.DOMAttr;
	lengthnode xmldom.DOMAttr;
	lengthspecified Boolean;
	uniquenode xmldom.DOMAttr;
	uniquespecified Boolean;
	refnode xmldom.DOMAttr;
	refspecified Boolean;
	Begin
		S:='';
		for j IN 0..xmldom.getLength(NLcollist)-1
		Loop		
			colelem := xmldom.makeelement(xmldom.item(NLcollist, j));

			if j>0 then
				S:=S || ', ';
			End if;

			--OSZLOPNV #REQUIED
			colnamenode:=xmldom.getAttributeNode(colelem, 'name'); 
			S:=S || xmldom.getvalue(colnamenode) || ' ';

			--OSZLOPTPUS #REQUIED
			coltypenode:=xmldom.getAttributeNode(colelem, 'type'); 
			S:=S || xmldom.getvalue(coltypenode);
			--LENGTH #IMPLIED
			lengthnode:=xmldom.getAttributeNode(colelem, 'length');
 			lengthspecified:=not xmldom.IsNull(lengthnode);
			if lengthspecified then
				S:=S || '(' || xmldom.getvalue(lengthnode) || ')';
			end if;


			--REF #IMPLIED
			refnode:=xmldom.getAttributeNode(colelem, 'ref');
			refspecified:=not xmldom.IsNull(refnode);
			if refspecified then
				S:=S || ' ';
				S:=S || 'References ' || getTransformedColRef(NLtablelist, refnode);
			end if;

			--UNIQUE #IMPLIED
			uniquenode:=xmldom.getAttributeNode(colelem, 'unique');
			uniquespecified:=not xmldom.IsNull(uniquenode);
			if uniquespecified then
				if xmldom.getvalue(uniquenode) = 'y' then
					S:=S || ' ';
					S:=S || 'UNIQUE';
				end if;
			end if;
		End Loop;

		Return S;
	End;

	-- Creates the 'create table' SQL
	Function getCreateTableSQL(NLtablelist xmldom.DOMNodeList, Ntablename IN xmldom.DOMAttr, NLcollist IN xmldom.DOMNodeList, NLprimarykeylist IN xmldom.DOMNodeList, NLforeignkeylist IN xmldom.DOMNodeList, IsConstraint IN Boolean) Return Varchar2
	IS
	S Varchar2(2000);
 	Begin
		S:='Create Table ' || 
			xmldom.getvalue(Ntablename) || 
			'(' || getColumnDescr(NLtablelist, NLcollist) || 
			getPrimaryKeyDescr(NLCollist, NLprimarykeylist, IsConstraint) || 
			getForeignKeyDescr(NLCollist, NLtablelist, NLforeignkeylist, IsConstraint) ||
			');';
		
			
		Return S;
	End;


-- converts XML to SQL script:
-- (MAIN PUBLIC PROCEDURE)
Procedure XML2DDL      (XML_URL		VARCHAR2,
			DDL_FILEDIR	VARCHAR2,
			DDL_FILENAME	VARCHAR2)
IS
	i number(4) Default 1;
	j number(4);

 	prs xmlparser.Parser;
	doc xmldom.DOMDocument;

	tablelist xmldom.DOMNodeList;
        tableelem xmlDOM.DOMElement;

	node xmldom.DOMNode;

	isconstraints Boolean;

	constraintnodelist xmldom.DOMNodeList;
	constraintnode xmldom.DOMNode;
	constraintelem xmlDOM.DOMElement;
	primarykeylist xmldom.DOMNodeList;	
	foreignkeylist xmldom.DOMNodeList;	

	collist xmldom.DOMNodeList;

        tablenamenode xmldom.DOMAttr;

	targetFile utl_file.File_Type;
Begin
	-- get a new parser and set error log and validation
	prs := xmlparser.newParser;
	-- parse the DTD and sets the parsed dtd for document validation
	xmlparser.parseDTD(prs, DTD_URL, 'database');
	xmlparser.setDocType(prs, xmlparser.getDocType(prs));
	-- parse the xml document
	xmlparser.parse(prs, XML_URL);
	doc := xmlparser.getDocument(prs);

	-- open target file
	targetFile := utl_file.FOpen (DDL_FILEDIR, DDL_FILENAME, 'w');

	tablelist := xmldom.getElementsByTagName(doc, 'table');
	for i IN 0..xmldom.getLength(tablelist)-1
	Loop
		--TBLA
		node := xmldom.item(tablelist, i); 
		tableelem := xmldom.makeelement(node);
		--TBLANV
		tablenamenode:=xmldom.getAttributeNode(tableelem, 'name'); 
		-- OSZLOP
		collist := xmldom.getElementsByTagName(tableelem, 'coloumn');	
		-- CONSTRAINTS
		constraintnodelist := xmldom.getElementsByTagName(tableelem, 'constraint');
		isconstraints := xmldom.getLength(constraintnodelist) > 0;
		if isconstraints then
			constraintnode :=xmldom.item(constraintnodelist, 0);
			constraintelem :=xmldom.makeelement(constraintnode);
			primarykeylist :=xmldom.getElementsByTagName(constraintelem, 'PrimaryKey');	
			foreignkeylist := xmldom.getElementsByTagName(constraintelem, 'ForeignKey');		
		End if;

		-- assemble SQL line and write to targetFile
		utl_file.put_line(targetFile, getCreateTableSQL(tablelist, tablenamenode,collist,primarykeylist,foreignkeylist,isconstraints));
	End Loop;
	xmlparser.freeparser(prs);

	-- close target file
	utl_file.FClose(targetFile);
End;

End DATA_XML2DDL;
/
